diff a/src/hotspot/share/libadt/vectset.hpp b/src/hotspot/share/libadt/vectset.hpp
--- a/src/hotspot/share/libadt/vectset.hpp
+++ b/src/hotspot/share/libadt/vectset.hpp
@@ -33,20 +33,21 @@
 // These sets can grow or shrink, based on the initial size and the largest
 // element currently in them.
 
 //------------------------------VectorSet--------------------------------------
 class VectorSet : public AnyObj {
+  friend VectorSet intersect(const VectorSet&, const VectorSet&);
+
 private:
 
   static const uint word_bits = 5;
   static const uint bit_mask  = 31;
 
   // Used 32-bit words
   uint       _size;
-  uint32_t*  _data;
   // Allocated words
-  uint       _data_size;
+  uint32_t*  _data;
   Arena*     _set_arena;
 
   void init(Arena* arena);
   // Grow vector to required word capacity
   void grow(uint new_word_capacity);
@@ -113,8 +114,13 @@
       grow(word);
     }
     uint32_t mask = 1U << (elem & bit_mask);
     _data[word] |= mask;
   }
+
+#ifndef PRODUCT
+  void print_on(outputStream* st) const override;
+#endif // PRODUCT
 };
 
+VectorSet intersect(const VectorSet& lhs, const VectorSet& rhs);
 #endif // SHARE_LIBADT_VECTSET_HPP
diff a/src/hotspot/share/opto/c2_globals.hpp b/src/hotspot/share/opto/c2_globals.hpp
--- a/src/hotspot/share/opto/c2_globals.hpp
+++ b/src/hotspot/share/opto/c2_globals.hpp
@@ -491,10 +491,33 @@
           "Exit or throw assert in EA when it reaches time limit")          \
                                                                             \
   notproduct(bool, PrintEscapeAnalysis, false,                              \
           "Print the results of escape analysis")                           \
                                                                             \
+  product(bool, DoPartialEscapeAnalysis, true, EXPERIMENTAL,                \
+          "Perform partial escape analysis")                                \
+                                                                            \
+  product(ccstr, PEAMethodOnly, nullptr, EXPERIMENTAL,                      \
+          "perform PEA for only matched methods")                           \
+                                                                            \
+  product(bool, PEAParanoid, false, EXPERIMENTAL,                           \
+          "Abort when C2 expands an object which has been materialized."    \
+          "Duplicated allocation is detected caused by PEA.")               \
+                                                                            \
+  notproduct(bool, PEAVerbose, false,                                       \
+          "trace PEA in verbose")                                           \
+                                                                            \
+  notproduct(intx, PEA_debug_idx, 0,                                        \
+          "only select ObjID in PEA when debug_idx > 0;"                    \
+          "skip ObjID if debug_idx < 0")                                    \
+                                                                            \
+  notproduct(intx, PEA_debug_start, 0,                                      \
+          "only start performing PEA after _debug_start")                   \
+                                                                            \
+  notproduct(intx, PEA_debug_stop, INT_MAX,                                 \
+          "stop performing PEA after (excluded) _debug_stop")               \
+                                                                            \
   product(bool, EliminateAllocations, true,                                 \
           "Use escape analysis to eliminate allocations")                   \
                                                                             \
   notproduct(bool, PrintEliminateAllocations, false,                        \
           "Print out when allocations are eliminated")                      \
diff a/src/hotspot/share/opto/callGenerator.cpp b/src/hotspot/share/opto/callGenerator.cpp
--- a/src/hotspot/share/opto/callGenerator.cpp
+++ b/src/hotspot/share/opto/callGenerator.cpp
@@ -642,10 +642,14 @@
     kit.replace_call(call, C->top(), true);
   } else {
     // Make a clone of the JVMState that appropriate to use for driving a parse
     JVMState* old_jvms = call->jvms();
     JVMState* jvms = old_jvms->clone_shallow(C);
+
+    // Clear the allocation state. We assume all inputs are materialized.
+    jvms->alloc_state().clear();
+
     uint size = call->req();
     SafePointNode* map = new SafePointNode(size, jvms);
     for (uint i1 = 0; i1 < size; i1++) {
       map->init_req(i1, call->in(i1));
     }
@@ -809,11 +813,11 @@
   return new LateInlineVectorReboxingCallGenerator(method, inline_cg);
 }
 
 //------------------------PredictedCallGenerator------------------------------
 // Internal class which handles all out-of-line calls checking receiver type.
-class PredictedCallGenerator : public CallGenerator {
+class PredictedCallGenerator : public InlineCallGenerator {
   ciKlass*       _predicted_receiver;
   CallGenerator* _if_missed;
   CallGenerator* _if_hit;
   float          _hit_prob;
   bool           _exact_check;
@@ -821,11 +825,11 @@
 public:
   PredictedCallGenerator(ciKlass* predicted_receiver,
                          CallGenerator* if_missed,
                          CallGenerator* if_hit, bool exact_check,
                          float hit_prob)
-    : CallGenerator(if_missed->method())
+    : InlineCallGenerator(if_missed->method())
   {
     // The call profile data may predict the hit_prob as extreme as 0 or 1.
     // Remove the extremes values from the range.
     if (hit_prob > PROB_MAX)   hit_prob = PROB_MAX;
     if (hit_prob < PROB_MIN)   hit_prob = PROB_MIN;
@@ -914,11 +918,10 @@
     return kit.transfer_exceptions_into_jvms();
   }
 
   // Fall through if the instance matches the desired type.
   kit.replace_in_map(receiver, casted_receiver);
-
   // Make the hot call:
   JVMState* new_jvms = _if_hit->generate(kit.sync_jvms());
   if (new_jvms == nullptr) {
     // Inline failed, so make a direct call.
     assert(_if_hit->is_inline(), "must have been a failed inline");
@@ -943,10 +946,13 @@
   // There are 2 branches and the replaced nodes are only valid on
   // one: restore the replaced nodes to what they were before the
   // branch.
   kit.map()->set_replaced_nodes(replaced_nodes);
 
+  PEAState& slow_as = slow_jvms->alloc_state();
+  PEAState& as = new_jvms->alloc_state();
+  AllocationStateMerger as_merger(as);
   // Finish the diamond.
   kit.C->set_has_split_ifs(true); // Has chance for split-if optimization
   RegionNode* region = new RegionNode(3);
   region->init_req(1, kit.control());
   region->init_req(2, slow_map->control());
@@ -976,12 +982,19 @@
     if (m != n) {
       const Type* t = gvn.type(m)->meet_speculative(gvn.type(n));
       Node* phi = PhiNode::make(region, m, t);
       phi->set_req(2, n);
       kit.map()->set_req(i, gvn.transform(phi));
+      if (DoPartialEscapeAnalysis) {
+        as_merger.merge_at_phi_creation(kit.PEA(), slow_as, phi->as_Phi(), m, n);
+      }
     }
   }
+
+  if (DoPartialEscapeAnalysis) {
+    as_merger.merge(slow_as, &kit, region, 2);
+  }
   return kit.transfer_exceptions_into_jvms();
 }
 
 
 CallGenerator* CallGenerator::for_method_handle_call(JVMState* jvms, ciMethod* caller, ciMethod* callee, bool allow_inline) {
@@ -1154,25 +1167,24 @@
   return nullptr;
 }
 
 //------------------------PredicatedIntrinsicGenerator------------------------------
 // Internal class which handles all predicated Intrinsic calls.
-class PredicatedIntrinsicGenerator : public CallGenerator {
+class PredicatedIntrinsicGenerator : public InlineCallGenerator {
   CallGenerator* _intrinsic;
   CallGenerator* _cg;
 
 public:
   PredicatedIntrinsicGenerator(CallGenerator* intrinsic,
                                CallGenerator* cg)
-    : CallGenerator(cg->method())
+    : InlineCallGenerator(cg->method())
   {
     _intrinsic = intrinsic;
     _cg        = cg;
   }
 
   virtual bool      is_virtual()   const    { return true; }
-  virtual bool      is_inline()    const    { return true; }
   virtual bool      is_intrinsic() const    { return true; }
 
   virtual JVMState* generate(JVMState* jvms);
 };
 
@@ -1241,10 +1253,11 @@
     assert(old_exc == new_map->next_exception(), "generate_predicate should not add exceptions");
 #endif
     if (!kit.stopped()) {
       PreserveJVMState pjvms(&kit);
       // Generate intrinsic code:
+      assert(_intrinsic->is_inline(), "LibraryIntrinsic");
       JVMState* new_jvms = _intrinsic->generate(kit.sync_jvms());
       if (new_jvms == nullptr) {
         // Intrinsic failed, use normal compilation path for this predicate.
         slow_region->add_req(kit.control());
       } else {
diff a/src/hotspot/share/opto/callGenerator.hpp b/src/hotspot/share/opto/callGenerator.hpp
--- a/src/hotspot/share/opto/callGenerator.hpp
+++ b/src/hotspot/share/opto/callGenerator.hpp
@@ -26,10 +26,11 @@
 #define SHARE_OPTO_CALLGENERATOR_HPP
 
 #include "compiler/compileBroker.hpp"
 #include "opto/callnode.hpp"
 #include "opto/compile.hpp"
+#include "opto/partialEscape.hpp"
 #include "opto/type.hpp"
 #include "runtime/deoptimization.hpp"
 
 //---------------------------CallGenerator-------------------------------------
 // The subclasses of this class handle generation of ideal nodes for
diff a/src/hotspot/share/opto/callnode.cpp b/src/hotspot/share/opto/callnode.cpp
--- a/src/hotspot/share/opto/callnode.cpp
+++ b/src/hotspot/share/opto/callnode.cpp
@@ -276,10 +276,11 @@
   _monoff = _stkoff + _method->max_stack();
   _scloff = _monoff;
   _endoff = _monoff;
   _sp = 0;
 }
+
 JVMState::JVMState(int stack_size) :
   _method(nullptr) {
   _bci = InvocationEntryBci;
   _reexecute = Reexecute_Undefined;
   debug_only(_map = (SafePointNode*)-1);
@@ -612,10 +613,11 @@
   n->set_monoff(_monoff);
   n->set_scloff(_scloff);
   n->set_endoff(_endoff);
   n->set_sp(_sp);
   n->set_map(_map);
+  n->_alloc_state = _alloc_state;
   return n;
 }
 
 //---------------------------clone_deep----------------------------------------
 JVMState* JVMState::clone_deep(Compile* C) const {
@@ -1574,11 +1576,11 @@
 uint AllocateNode::size_of() const { return sizeof(*this); }
 
 AllocateNode::AllocateNode(Compile* C, const TypeFunc *atype,
                            Node *ctrl, Node *mem, Node *abio,
                            Node *size, Node *klass_node, Node *initial_test)
-  : CallNode(atype, nullptr, TypeRawPtr::BOTTOM)
+  : CallNode(atype, nullptr, TypeRawPtr::BOTTOM), _materialized(0)
 {
   init_class_id(Class_Allocate);
   init_flags(Flag_is_macro);
   _is_scalar_replaceable = false;
   _is_non_escaping = false;
@@ -1619,10 +1621,20 @@
   // For now only enable fast locking for non-array types
   mark_node = phase->MakeConX(markWord::prototype().value());
   return mark_node;
 }
 
+// This is a precise notnull oop of the klass.
+// (Actually, it need not be precise if this is a reflective allocation.)
+// It's what we cast the result to.
+const TypeOopPtr* AllocateNode::oop_type(const PhaseValues& phase) const {
+  Node* klass_node = in(KlassNode);
+  const TypeKlassPtr* tklass = phase.type(klass_node)->isa_klassptr();
+  if (!tklass) tklass = TypeInstKlassPtr::OBJECT;
+  return tklass->as_instance_type();
+}
+
 // Retrieve the length from the AllocateArrayNode. Narrow the type with a
 // CastII, if appropriate.  If we are not allowed to create new nodes, and
 // a CastII is appropriate, return null.
 Node *AllocateArrayNode::make_ideal_length(const TypeOopPtr* oop_type, PhaseValues* phase, bool allow_new_nodes) {
   Node *length = in(AllocateNode::ALength);
diff a/src/hotspot/share/opto/callnode.hpp b/src/hotspot/share/opto/callnode.hpp
--- a/src/hotspot/share/opto/callnode.hpp
+++ b/src/hotspot/share/opto/callnode.hpp
@@ -27,10 +27,11 @@
 
 #include "opto/connode.hpp"
 #include "opto/mulnode.hpp"
 #include "opto/multnode.hpp"
 #include "opto/opcodes.hpp"
+#include "opto/partialEscape.hpp"
 #include "opto/phaseX.hpp"
 #include "opto/replacednodes.hpp"
 #include "opto/type.hpp"
 #include "utilities/growableArray.hpp"
 
@@ -206,10 +207,12 @@
   uint              _sp;        // Java Expression Stack Pointer for this state
   int               _bci;       // Byte Code Index of this JVM point
   ReexecuteState    _reexecute; // Whether this bytecode need to be re-executed
   ciMethod*         _method;    // Method Pointer
   SafePointNode*    _map;       // Map node associated with this scope
+  PEAState          _alloc_state;
+
 public:
   friend class Compile;
   friend class PreserveReexecuteState;
 
   // Because JVMState objects live over the entire lifetime of the
@@ -299,10 +302,11 @@
   JVMState* clone_deep(Compile* C) const;    // recursively clones caller chain
   JVMState* clone_shallow(Compile* C) const; // retains uncloned caller
   void      set_map_deep(SafePointNode *map);// reset map for all callers
   void      adapt_position(int delta);       // Adapt offsets in in-array after adding an edge.
   int       interpreter_frame_size() const;
+  PEAState& alloc_state() { return _alloc_state; }
 
 #ifndef PRODUCT
   void      print_method_with_lineno(outputStream* st, bool show_name) const;
   void      format(PhaseRegAlloc *regalloc, const Node *n, outputStream* st) const;
   void      dump_spec(outputStream *st) const;
@@ -947,10 +951,13 @@
 //  the _is_io_use flag in the projection.)  This is needed when expanding the node in
 //  order to differentiate the uses of the projection on the normal control path from
 //  those on the exception return path.
 //
 class AllocateNode : public CallNode {
+private:
+  int _materialized; // materializaiton counts by PEA
+
 public:
   enum {
     // Output:
     RawAddress  = TypeFunc::Parms,    // the newly-allocated raw address
     // Inputs:
@@ -1050,13 +1057,23 @@
   // If object doesn't escape in <.init> method and there is memory barrier
   // inserted at exit of its <.init>, memory barrier for new is not necessary.
   // Inovke this method when MemBar at exit of initializer and post-dominate
   // allocation node.
   void compute_MemBar_redundancy(ciMethod* initializer);
-  bool is_allocation_MemBar_redundant() { return _is_allocation_MemBar_redundant; }
+  bool is_allocation_MemBar_redundant() const { return _is_allocation_MemBar_redundant; }
 
   Node* make_ideal_mark(PhaseGVN *phase, Node* obj, Node* control, Node* mem);
+
+  const TypeOopPtr* oop_type(const PhaseValues& phase) const;
+
+  void inc_materialized() {
+    _materialized++;
+  }
+
+  int materialized_cnt() const {
+    return _materialized;
+  }
 };
 
 //------------------------------AllocateArray---------------------------------
 //
 // High-level array allocation
diff a/src/hotspot/share/opto/compile.cpp b/src/hotspot/share/opto/compile.cpp
--- a/src/hotspot/share/opto/compile.cpp
+++ b/src/hotspot/share/opto/compile.cpp
@@ -646,10 +646,11 @@
                   _template_assertion_predicate_opaqs (comp_arena(), 8, 0, nullptr),
                   _expensive_nodes   (comp_arena(), 8, 0, nullptr),
                   _for_post_loop_igvn(comp_arena(), 8, 0, nullptr),
                   _unstable_if_traps (comp_arena(), 8, 0, nullptr),
                   _coarsened_locks   (comp_arena(), 8, 0, nullptr),
+                  _pea(nullptr),
                   _congraph(nullptr),
                   NOT_PRODUCT(_igv_printer(nullptr) COMMA)
                   _unique(0),
                   _dead_node_count(0),
                   _dead_node_list(comp_arena()),
@@ -736,10 +737,14 @@
   _types = new (comp_arena()) Type_Array(comp_arena());
   _node_hash = new (comp_arena()) NodeHash(comp_arena(), estimated_size);
   PhaseGVN gvn;
   set_initial_gvn(&gvn);
 
+  if (DoPartialEscapeAnalysis) {
+    _pea = new (mtCompiler) PartialEscapeAnalysis(comp_arena());
+  }
+
   print_inlining_init();
   { // Scope for timing the parser
     TracePhase tp("parse", &timers[_t_parser]);
 
     // Put top into the hash table ASAP.
diff a/src/hotspot/share/opto/compile.hpp b/src/hotspot/share/opto/compile.hpp
--- a/src/hotspot/share/opto/compile.hpp
+++ b/src/hotspot/share/opto/compile.hpp
@@ -46,10 +46,11 @@
 #include "runtime/vmThread.hpp"
 #include "utilities/ticks.hpp"
 
 class AbstractLockNode;
 class AddPNode;
+class AllocateNode;
 class Block;
 class Bundle;
 class CallGenerator;
 class CallStaticJavaNode;
 class CloneMap;
@@ -69,10 +70,11 @@
 class Node_Notes;
 class NodeHash;
 class NodeCloneInfo;
 class OptoReg;
 class ParsePredicateNode;
+class PartialEscapeAnalysis;
 class PhaseCFG;
 class PhaseGVN;
 class PhaseIterGVN;
 class PhaseRegAlloc;
 class PhaseCCP;
@@ -96,10 +98,12 @@
 class nmethod;
 class Node_Stack;
 struct Final_Reshape_Counts;
 class VerifyMeetResult;
 
+typedef AllocateNode* ObjID;
+
 enum LoopOptsMode {
   LoopOptsDefault,
   LoopOptsNone,
   LoopOptsMaxUnroll,
   LoopOptsShenandoahExpand,
@@ -357,10 +361,11 @@
   int                   _loop_opts_cnt;         // loop opts round
   uint                  _stress_seed;           // Seed for stress testing
 
   // Compilation environment.
   Arena                 _comp_arena;            // Arena with lifetime equivalent to Compile
+  Arena*                _parser_arena;          // Arena with lifttime equivalent to the top-level parser.
   void*                 _barrier_set_state;     // Potential GC barrier state for Compile
   ciEnv*                _env;                   // CI interface
   DirectiveSet*         _directive;             // Compiler directive
   CompileLog*           _log;                   // from CompilerThread
   const char*           _failure_reason;        // for record_failure/failing pattern
@@ -371,10 +376,11 @@
   GrowableArray<Node*>  _template_assertion_predicate_opaqs; // List of Opaque4 nodes for Template Assertion Predicates.
   GrowableArray<Node*>  _expensive_nodes;       // List of nodes that are expensive to compute and that we'd better not let the GVN freely common
   GrowableArray<Node*>  _for_post_loop_igvn;    // List of nodes for IGVN after loop opts are over
   GrowableArray<UnstableIfTrap*> _unstable_if_traps;        // List of ifnodes after IGVN
   GrowableArray<Node_List*> _coarsened_locks;   // List of coarsened Lock and Unlock nodes
+  PartialEscapeAnalysis* _pea;
   ConnectionGraph*      _congraph;
 #ifndef PRODUCT
   IdealGraphPrinter*    _igv_printer;
   static IdealGraphPrinter* _debug_file_printer;
   static IdealGraphPrinter* _debug_network_printer;
@@ -779,10 +785,15 @@
   }
   void add_coarsened_locks(GrowableArray<AbstractLockNode*>& locks);
   void remove_coarsened_lock(Node* n);
   bool coarsened_locks_consistent();
 
+  PartialEscapeAnalysis* PEA() const {
+    assert(!DoPartialEscapeAnalysis || _pea != nullptr, "sanity check");
+    return _pea;
+  }
+
   bool       post_loop_opts_phase() { return _post_loop_opts_phase;  }
   void   set_post_loop_opts_phase() { _post_loop_opts_phase = true;  }
   void reset_post_loop_opts_phase() { _post_loop_opts_phase = false; }
 
   void record_for_post_loop_opts_igvn(Node* n);
@@ -805,10 +816,11 @@
   // Sort expensive nodes to locate similar expensive nodes
   void sort_expensive_nodes();
 
   // Compilation environment.
   Arena*      comp_arena()           { return &_comp_arena; }
+  Arena*      parser_arena()         { return comp_arena(); } // for the time being, just return comp_arena.
   ciEnv*      env() const            { return _env; }
   CompileLog* log() const            { return _log; }
   bool        failing() const        { return _env->failing() || _failure_reason != nullptr; }
   const char* failure_reason() const { return (_env->failing()) ? _env->failure_reason() : _failure_reason; }
   const CompilationFailureInfo* first_failure_details() const { return _first_failure_details; }
diff a/src/hotspot/share/opto/doCall.cpp b/src/hotspot/share/opto/doCall.cpp
--- a/src/hotspot/share/opto/doCall.cpp
+++ b/src/hotspot/share/opto/doCall.cpp
@@ -660,10 +660,38 @@
 #endif // not PRODUCT
 
   assert(jvms == this->jvms(), "still operating on the right JVMS");
   assert(jvms_in_sync(),       "jvms must carry full info into CG");
 
+  PEAState* caller_state = nullptr;
+  if (DoPartialEscapeAnalysis) {
+    // Besides outlined methods, we scan all intrinsics because C2 skips parsing bytecodes of them.
+    // Some intrinsics have side-effect of Java heap such as Unsafe.compareAndSetReference().
+    // We treat PredicatedIntrinsicGenerator as an ordinary intrinsic as well.
+    if (!cg->is_inline() || cg->is_intrinsic()) {
+      PEAState& state = jvms->alloc_state();
+      // Materialize all inputs to non-inline and late inline calls.
+      // TODO: we can support late inline calls if we can pass the right JVM
+      // state to the late inline call.
+      //
+      // TODO: Should we query BCEA to make an enger inlining decision here?
+      // Because callee require a concrete object pointer as an argument,
+      // we have nothing to do but matertialize it.
+      //
+      // BCEscapeAnalyzer* bcea = cg->method()->get_bcea();
+      uint nargs = cg->method()->arg_size();
+      for (uint i=0; i < nargs; ++i) {
+        Node* arg = argument(i);
+
+        if (state.as_virtual(PEA(), arg)) {
+          Node* objx = state.materialize(this, arg);
+          set_argument(i, objx);
+        }
+      }
+    }
+  }
+
   // save across call, for a subsequent cast_not_null.
   Node* receiver = has_receiver ? argument(0) : nullptr;
 
   // The extra CheckCastPPs for speculative types mess with PhaseStringOpts
   if (receiver != nullptr && !call_does_dispatch && !cg->is_string_late_inline()) {
diff a/src/hotspot/share/opto/graphKit.cpp b/src/hotspot/share/opto/graphKit.cpp
--- a/src/hotspot/share/opto/graphKit.cpp
+++ b/src/hotspot/share/opto/graphKit.cpp
@@ -1026,10 +1026,12 @@
     // Update the two tail pointers in parallel.
     out_jvms = out_jvms->caller();
     in_jvms  = in_jvms->caller();
   }
 
+  PEAState& as = youngest_jvms->alloc_state();
+  backfill_materialized(call, TypeFunc::Parms, call->req(), as);
   assert(debug_ptr == non_debug_edges, "debug info must fit exactly");
 
   // Test the correctness of JVMState::debug_xxx accessors:
   assert(call->jvms()->debug_start() == non_debug_edges, "");
   assert(call->jvms()->debug_end()   == call->req(), "");
@@ -3513,23 +3515,65 @@
   }
 #endif
 
   return flock;
 }
+// Clone LockNode for PEA materialization.
+// LockNode is a safepoint, so it's location sensitive. We can't just clone it.
+// We create it using the current JVMState and mark bytecode non-reexecute.
+//
+// It is worthy noting that we reuse BoxNode. It represents the slot on stack.
+// PhaseMacroExpand::mark_eliminated_box() can't eliminate BoxLockNode and its
+// associated AbstractLockNodes until share prove that the 'eliminated' BoxLockNode
+// is exclusive.
+void GraphKit::clone_shared_lock(Node* box, Node* obj) {
+  kill_dead_locals();
+
+  Node* mem = reset_memory();
+
+  FastLockNode * flock = _gvn.transform(new FastLockNode(0, obj, box) )->as_FastLock();
+  const TypeFunc *tf = LockNode::lock_type();
+  LockNode *lock = new LockNode(C, tf);
+
+  lock->set_req(TypeFunc::Control, control());
+  lock->set_req(TypeFunc::Memory , mem);
+  lock->set_req(TypeFunc::I_O    , top())     ;   // does no i/o
+  lock->set_req(TypeFunc::FramePtr, frameptr());
+  lock->set_req(TypeFunc::ReturnAdr, top());
 
+  lock->set_req(TypeFunc::Parms + 0, obj);
+  lock->set_req(TypeFunc::Parms + 1, box);
+  lock->set_req(TypeFunc::Parms + 2, flock);
+
+  // we can't reexecute current bc. it's not monitorenter.
+  jvms()->set_should_reexecute(false);
+  add_safepoint_edges(lock);
+
+  lock = _gvn.transform( lock )->as_Lock();
+
+  // lock has no side-effects, sets few values
+  set_predefined_output_for_runtime_call(lock, mem, TypeRawPtr::BOTTOM);
+
+  insert_mem_bar(Op_MemBarAcquireLock);
+
+  // Add this to the worklist so that the lock can be eliminated
+  record_for_igvn(lock);
+}
 
 //------------------------------shared_unlock----------------------------------
 // Emit unlocking code.
-void GraphKit::shared_unlock(Node* box, Node* obj) {
+void GraphKit::shared_unlock(Node* box, Node* obj, bool preserve_monitor) {
   // bci is either a monitorenter bc or InvocationEntryBci
   // %%% SynchronizationEntryBCI is redundant; use InvocationEntryBci in interfaces
   assert(SynchronizationEntryBCI == InvocationEntryBci, "");
 
   if( !GenerateSynchronizationCode )
     return;
   if (stopped()) {               // Dead monitor?
-    map()->pop_monitor();        // Kill monitor from debug info
+    if (!preserve_monitor) {
+      map()->pop_monitor();        // Kill monitor from debug info
+    }
     return;
   }
 
   // Memory barrier to avoid floating things down past the locked region
   insert_mem_bar(Op_MemBarReleaseLock);
@@ -3552,13 +3596,14 @@
 
   Node* mem = reset_memory();
 
   // unlock has no side-effects, sets few values
   set_predefined_output_for_runtime_call(unlock, mem, TypeRawPtr::BOTTOM);
-
-  // Kill monitor from debug info
-  map()->pop_monitor( );
+  if (!preserve_monitor) {
+    // Kill monitor from debug info
+    map()->pop_monitor();
+  }
 }
 
 //-------------------------------get_layout_helper-----------------------------
 // If the given klass is a constant or known to be an array,
 // fetch the constant layout helper value into constant_value
@@ -3602,18 +3647,14 @@
 
   Node* prevmem = kit.memory(alias_idx);
   init_in_merge->set_memory_at(alias_idx, prevmem);
   kit.set_memory(init_out_raw, alias_idx);
 }
-
-//---------------------------set_output_for_allocation-------------------------
-Node* GraphKit::set_output_for_allocation(AllocateNode* alloc,
+Node* GraphKit::set_output_for_allocation_common(AllocateNode* alloc,
                                           const TypeOopPtr* oop_type,
                                           bool deoptimize_on_exception) {
   int rawidx = Compile::AliasIdxRaw;
-  alloc->set_req( TypeFunc::FramePtr, frameptr() );
-  add_safepoint_edges(alloc);
   Node* allocx = _gvn.transform(alloc);
   set_control( _gvn.transform(new ProjNode(allocx, TypeFunc::Control) ) );
   // create memory projection for i_o
   set_memory ( _gvn.transform( new ProjNode(allocx, TypeFunc::Memory, true) ), rawidx );
   make_slow_call_ex(allocx, env()->Throwable_klass(), true, deoptimize_on_exception);
@@ -3688,10 +3729,66 @@
 #endif //ASSERT
 
   return javaoop;
 }
 
+//---------------------------set_output_for_allocation-------------------------
+Node* GraphKit::set_output_for_allocation(AllocateNode* alloc,
+                                          const TypeOopPtr* oop_type,
+                                          bool deoptimize_on_exception) {
+  alloc->set_req( TypeFunc::FramePtr, frameptr() );
+  add_safepoint_edges(alloc);
+  return set_output_for_allocation_common(alloc, oop_type, deoptimize_on_exception);
+}
+
+//
+// Position-Agnostic Materialization
+// -------------------------------------
+// When PEA materializes a virtual object, it emits a cluster of nodes in the current position.
+// Unlike ordinary "floating" nodes, an AllocateNode is a subclass of SafePointNode so it is
+// dependent on JVMState. The JVMState of current position may not fit for an AllocateNode.
+//
+// To ensure we can safely embed nodes into the curren position, we have the following
+// measures:
+//
+// 1. Debug edges and JVMState of the cloned AllocateNode are not from current GraphKit.
+// We copy them from the original AllocateNode instead.
+//
+// 2. Choose deoptimization on exception. A real exception may be mistakenly dispatched to
+// the exception handler in current context.
+//
+Node* GraphKit::materialize_object(AllocateNode* alloc, const TypeOopPtr* oop_type) {
+  Node *mem = reset_memory();
+  AllocateNode* allocx  = new AllocateNode(C, alloc->tf(), control(), mem, i_o(),
+                                           alloc->in(AllocateNode::AllocSize),
+                                           alloc->in(AllocateNode::KlassNode),
+                                           alloc->in(AllocateNode::InitialTest));
+  allocx->set_req(TypeFunc::FramePtr, frameptr());
+
+  JVMState* out_jvms = alloc->jvms()->clone_shallow(C);
+  out_jvms->bind_map(allocx);
+  // copy all debuginfo edges from the original AllocateNode
+  for (uint i=allocx->req(); i < alloc->req(); ++i) {
+    allocx->add_req(alloc->in(i));
+  }
+
+  JVMState* jvms = sync_jvms();
+  // We can not use PreserveJVMState here because 'this' is a Parse. We would fail in jvms_in_sync().
+  GraphKit kit(allocx->jvms());
+  kit.set_map_clone(allocx);
+
+  Node* objx = kit.set_output_for_allocation_common(allocx, oop_type, true /*deoptimize_on_ex*/);
+
+  // copy back compile-time state to 'this'.
+  set_jvms(jvms);
+  set_control(kit.control());
+  set_i_o(kit.i_o());
+  set_all_memory(kit.merged_memory());
+
+  return objx;
+}
+
 //---------------------------new_instance--------------------------------------
 // This routine takes a klass_node which may be constant (for a static type)
 // or may be non-constant (for reflective code).  It will work equally well
 // for either, and the graph will fold nicely if the optimizer later reduces
 // the type to a constant.
@@ -4248,5 +4345,33 @@
   if (con_type != nullptr) {
     return makecon(con_type);
   }
   return nullptr;
 }
+
+void GraphKit::backfill_materialized(SafePointNode* map, uint begin, uint end, PEAState& as){
+  bool printed = false;
+
+  for (uint i = begin; i < end; ++i) {
+    Node* t = map->in(i);
+
+    if (t != nullptr && t->is_CheckCastPP()) {
+      AllocateNode* alloc = AllocateNode::Ideal_allocation(t);
+
+      if (as.contains(alloc)) {
+        Node* neww = as.get_materialized_value(alloc);
+        if (neww != nullptr && neww != t) {
+#ifndef PRODUCT
+          if (PEAVerbose) {
+            if (!printed) {
+              map->dump();
+              printed = true;
+            }
+            tty->print_cr("[PEA] replace %d with node %d", i, neww->_idx);
+          }
+#endif
+          map->set_req(i, neww);
+        }
+      }
+    }
+  }
+}
